/*
 * openft.h
 *
 * Copyright (C) 2001-2002 giFT project (gift.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

/* NOTE - i have decided to sack compile time for header sanity ... please
 * shoot me */

#ifndef __OPENFT_H__
#define __OPENFT_H__

/**************************************************************************/

/* TODO - fix this with autoconf */
typedef unsigned char  ft_uint8;
typedef unsigned short ft_uint16;
typedef unsigned long  ft_uint32;

/**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gift.h"
#include "download.h"
#include "upload.h"
#include "event.h"

#include "list.h"
#include "hash.h"

#include "protocol.h"
#include "network.h"
#include "node.h"

#include "share.h"

#include "conf.h"
#include "utils.h"

#include "packet.h"

/* #include <tcgprof.h> */
#include <assert.h>

/*****************************************************************************/

#define trace_sock(fd,msg) \
printf ("*** %s (%s): %s\n", net_peer_ip (fd), __PRETTY_FUNCTION__, (msg ? msg : ""))

/*****************************************************************************/

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

/*****************************************************************************/

/* registered callbacks to report transfer statistics to the daemon */
void ft_upload   (Connection *c, Chunk *chunk, char *segment, size_t len);
void ft_download (Connection *c, Chunk *chunk, char *segment, size_t len);

int  OpenFT_init (Protocol *p);

/*****************************************************************************/

#endif /* __OPENFT_H__ */
