/*
 * share.h
 *
 * Copyright (C) 2001-2002 giFT project (gift.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef __SHARE_H
#define __SHARE_H

/*****************************************************************************/

typedef struct
{
	unsigned long  host;       /* ip of the user who owns this share */
	unsigned short port;
	unsigned short http_port;

	char          *file;
	char          *md5;
	unsigned long  size;

	ft_uint32     *tokens; /* list of tokens for quick searching */
} FileShare;

/*****************************************************************************/

int        share_complete       (FileShare *file);
void       share_free           (FileShare *file);
FileShare *share_new            (char *host, unsigned short port,
                                 unsigned short http_port,
                                 unsigned long size, char *md5, char *file);
void       share_add            (FileShare *file);
void       share_remove         (FileShare *file);
void       share_remove_by_host (char *host);

void  share_local_clear           ();
void  share_local_add             (FileShare *file);
void  share_local_import          ();
int   share_local_find            (char *filename);
void  share_local_submit          (Protocol *p, Connection *c);
void  share_local_foreach         (HashFunc func, void *data);

void share_stats_reset  (Connection *c);
void share_stats_add    (Connection *c, FileShare *file);
void share_stats_remove (Connection *c, FileShare *file);
void share_stats_set    (Connection *c, unsigned long users,
						 unsigned long shares, unsigned long megs);

/*****************************************************************************/

#endif /* __SHARE_H */
