#!/usr/bin/perl

# giFT.cgi: a CGI interface to a giFT daemon running on localhost port 1213

use IO::Socket;
use CGI;

# Output the header

$| = 1;

# Parse the CGI input

CGI::ReadParse();

# Was this a metaquery?
if ($in{'metaquery'} == 1) {
    print "Content-Type: application/x-gift-query\n\n";
    $uri = "http://" . $ENV{'SERVER_NAME'} . ':' . $ENV{'SERVER_PORT'} .
	$ENV{'REQUEST_URI'};
    $uri =~ s/metaquery=1&/query=&raw=1&/;
    print $uri, "\n";
    exit;
}

# Do we want to output just the raw search results?
$rawresults = 1 if $in{'raw'} == 1;

# Figure out the realm
if (defined $in{'realm'}) {
    $realm = "\L$in{'realm'}\E";
} else {
    $realm = "everything";
}
$sel{$realm} = 'CHECKED';

# Make the properly-escaped query value
if (defined $in{'query'}) {
    $qval = &escape($in{'query'});
} else {
    $qval = '';
}

# Output the main part of the form
if ($rawresults) {
    print "Content-Type: text/plain\n\n";
}
print <<EOF unless $rawresults;
Content-Type: text/html

<HTML><HEAD><TITLE>giFT CGI interface</TITLE></HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF"><H1 ALIGN=CENTER>giFT CGI interface</H1>
<P ALIGN=CENTER>the <b>g</b>eneric <b>i</b>nterface to <b>F</b>ast<b>T</b>rack
<br>or
<br><b>g</b>iFT <b>i</b>sn't <b>F</b>ast<b>T</b>rack
</P>
<FORM METHOD=GET>
<P>Query: <INPUT NAME=query VALUE="$qval"> <INPUT TYPE=SUBMIT VALUE="Search!">
<P><INPUT TYPE=radio NAME=realm VALUE=Everything $sel{'everything'}> Everything
<br><INPUT TYPE=radio NAME=realm VALUE=Images $sel{'images'}> Images
<br><INPUT TYPE=radio NAME=realm VALUE=Audio $sel{'audio'}> Audio
<br><INPUT TYPE=radio NAME=realm VALUE=Video $sel{'video'}> Video
<br><INPUT TYPE=radio NAME=realm VALUE=Documents $sel{'documents'}> Documents
<br><INPUT TYPE=radio NAME=realm VALUE=Software $sel{'software'}> Software
<br><INPUT TYPE=radio NAME=realm VALUE=MD5 $sel{'md5'}> MD5
EOF

# Print the parts of the form dependent on the advanced level
if ($in{'advanced'} == 1) {
    $adv = 1;
    $noadv = 0;
    $noadvs = 'Basic';
    $artist = &escape($in{'artist'});
    $album = &escape($in{'album'});
    $title = &escape($in{'title'});
    $size = &escape($in{'size'});
    $sizeopt = $in{'sizeopt'};
    $sizeosel{$sizeopt} = 'SELECTED';
    $yearmin = &escape($in{'yearmin'});
    $yearmax = &escape($in{'yearmax'});
    $hashsearch = &escape($in{'hash'});
    print <<EOF unless $rawresults;
<P>Advanced query options:
<BR>Artist: <INPUT NAME="artist" VALUE="$artist">
<BR>Album: <INPUT NAME="album" VALUE="$album">
<BR>Title: <INPUT NAME="title" VALUE="$title">
<BR>Size: <SELECT NAME="sizeopt">
    <OPTION VALUE="atleast" $sizeosel{'atleast'}>At least</OPTION>
    <OPTION VALUE="approx" $sizeosel{'approx'}>Approximately</OPTION>
    <OPTION VALUE="atmost" $sizeosel{'atmost'}>At most</OPTION>
</SELECT> <INPUT NAME="size" VALUE="$size"> KB
<BR>Year: Between <INPUT NAME="yearmin" VALUE="$yearmin"> and
<INPUT NAME="yearmax" VALUE="$yearmax">
<P><INPUT TYPE=SUBMIT VALUE="Search!">
EOF
} else {
    $adv = 0;
    $noadv = 1;
    $noadvs = 'Advanced';
    $hashsearch = &escape($in{'hash'});
}
print <<EOF unless $rawresults;
<INPUT TYPE=HIDDEN NAME=advanced VALUE=$adv></FORM>
<P><FORM METHOD=GET><INPUT TYPE=HIDDEN NAME=nosearch VALUE=1>
EOF
if (defined $in{'realm'}) {
    print "<INPUT TYPE=HIDDEN NAME=realm VALUE=\"$in{'realm'}\">\n" unless $rawresults;
}
if (defined $in{'query'}) {
    print "<INPUT TYPE=HIDDEN NAME=query VALUE=\"$qval\">\n" unless $rawresults;
}
print "<INPUT TYPE=HIDDEN NAME=advanced VALUE=$noadv><INPUT TYPE=SUBMIT VALUE=\"$noadvs query\"></FORM>\n" unless $rawresults;

if ($in{'nosearch'} == 1 || !defined $in{'query'}) {
    # Output the blank form
    print "</BODY></HTML>\n" unless $rawresults;
    exit;
}

print "<HR><P>Search results for \"$qval\":\n" unless $rawresults;
$opts = '';
$opts .= "query=\"$qval\" " if $qval ne '';
print "<BR><SMALL>Realm: \u$realm\n" unless $rawresults;
$opts .= "realm=\"$realm\" ";
if ($artist ne '') {
    print "<BR>Artist: $artist\n" unless $rawresults;
    $opts .= "artist=\"$artist\" ";
}
if ($album ne '') {
    print "<BR>Album: $album\n" unless $rawresults;
    $opts .= "album=\"$album\" ";
}
if ($title ne '') {
    print "<BR>Title: $title\n" unless $rawresults;
    $opts .= "title=\"$title\" ";
}
if ($size ne '') {
    $size *= 1024;
    $size = &symb($sizeopt) . $size;
    print "<BR>Size: $size\n" unless $rawresults;
    $opts .= "size=\"$size\" ";
}
if ($yearmin ne '') {
    $yearmin = "&gt;$yearmin";
    print "<BR>Year: $yearmin\n" unless $rawresults;
    $opts .= "year=\"$yearmin\" ";
}
if ($yearmax ne '') {
    $yearmax = "&lt;$yearmax";
    print "<BR>Year: $yearmax\n" unless $rawresults;
    $opts .= "year=\"$yearmax\" ";
}
if ($hashsearch ne '') {
    print "<BR>Hash: $hashsearch\n" unless $rawresults;
    $opts .= "hash=\"$hashsearch\" ";
}
print "</SMALL>\n" unless $rawresults;

# Connect to the local giFT daemon
$sock = IO::Socket::INET->new('localhost:1213');
if (!defined $sock) {
    print "<P>Local giFT daemon not running.\n" unless $rawresults;
    print "</BODY></HTML>\n" unless $rawresults;
    exit;
}

# Send the escaped query to the daemon
#print $sock "<br>&gt;&gt; &lt;connect protocol=OpenFT/&gt;\n";
#print $sock "<br>&gt;&gt; &lt;search $opts/&gt;\n";
print $sock "<connect protocol=OpenFT/>\n";
print $sock "<search $opts/>\n";

# Collect the results.  We use an OL instead of a table so that Netscape
# will display partial results as the list appears
print "<OL>\n" unless $rawresults;
while(<$sock>) {
    %attrs = ();

    # Make sure this is an <item/> tag
    /^<item\s+(.*?)\s*\/>/i || next;

    # Extract the attributes from the tag
    $atext = $1;
    while($atext =~ /(\S+?)=\"(.*?)\"/g) {
	$attrs{"\L$1\E"} = $2;
    }

    # We insist there be an href attribute
    next unless defined $attrs{'href'};

    # Weed out duplicates
    next if defined $seen{$attrs{'href'}};
    $seen{$attrs{'href'}} = 1;

    # Parse out the host/port pair, the short checksum, and the filename
    $attrs{'href'} =~ /^http:\/\/(.*?)\/(.*?)\/(.*)$/ or next;
    ($hostport, $checksum, $fname) = ($1, $2, $3);

    # Un-URL-escape the filename
    $fname =~ s/\+/ /g;
    $fname =~ s/%([0-9a-f][0-9a-f])/pack('C',hex $1)/eig;

    if ($rawresults) {
	if (! $rawheaderdone) {
	    $hash = $attrs{'hash'};
	    $hash =~ tr/0-9a-fA-F//cd;
	    $fname =~ tr/!-~/_/c;
	    print "HASH: $hash\n";
	    print "FILENAME: $fname\n";
	    print "FILESIZE: $attrs{'filesize'}\n";
	    $rawheaderdone = 1;
	}
	print "URL: ", $attrs{'href'}, "\n";
	next;
    }

    ## Now HTML-escape the filename
    $fname = &escape($fname);

    # Do we have a listed file size?
    if (defined $attrs{'filesize'}) {
	$length = " ($attrs{'filesize'} bytes)";
	delete $attrs{'filesize'};
    } else {
	$length = '';
    }

    # Do we have a listed username?
    if (defined $attrs{'user'}) {
	# Make a link back to the user's FastTrack client by stripping
	# off the checksum and filename part of the href
	$user = "<BR><A HREF=\"http://$hostport/\">$attrs{'user'}</A>\n";
	delete $attrs{'user'};
    } else {
	$user = '';
    }

    # Get the hash value
    if (defined $attrs{'hash'}) {
	# Make a link to a search for just that hash value
	$hashes{$attrs{'hash'}} += 1;
	$hash = "<BR><A HREF=\"giFT.cgi?realm=md5&query=$attrs{'hash'}\">$attrs{'hash'}</A> ($hashes{$attrs{'hash'}})\n";
	delete $attrs{'hash'}
    } else {
	$hash = '';
    }

    # Output a list entry for this result
    print "<LI><DL><DT><A HREF=\"$attrs{'href'}\">$fname</A>$length\n$user$hash</DT><DD><SMALL>\n";

    # Remove the href, which we've already seen
    delete $attrs{'href'};

    # Output the remaining attrs
    foreach $k (sort keys %attrs) {
	print "<B>$k:</B> \"$attrs{$k}\"<BR>\n";
    }
    # Finish the list entry
    print "</SMALL></DD></DL>\n";
}

print "</OL></BODY></HTML>\n" unless $rawresults;

sub escape {
    my $r = $_[0];
    $r =~ s/&/&amp;/g;
    $r =~ s/</&lt;/g;
    $r =~ s/>/&gt;/g;
    $r =~ s/"/&quot;/g;
    $r =~ s/[\000-\037\177-\377]/sprintf "&#%d;", unpack('C', $&)/ge;
    $r;
}

sub symb {
    my $s = $_[0];
    return "&gt;" if $s eq 'atleast';
    return "&lt;" if $s eq 'atmost';
    return "=" if $s eq 'equals';
    return "*" if $s eq 'substr';
    return "~" if $s eq 'approx';
    return "=";
}
