/*
 * gift.h
 *
 * Copyright (C) 2001-2002 giFT project (gift.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef __GIFT_H
#define __GIFT_H

/*****************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define GIFT_CVSID "$Id: gift.h,v 1.8 2002/01/30 22:54:01 jasta Exp $"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <unistd.h>

/* #include <tcgprof.h> */
#include <assert.h>

/*****************************************************************************/

#include "parse.h"
#include "hash.h"
#include "connection.h"
#include "protocol.h"
#include "interface.h"
#include "if_event.h"

/*****************************************************************************/

#define DEBUG

#ifdef DEBUG
# define GIFT_DEBUG(args) (fprintf (stderr, "** gift-debug:   "), printf args, printf ("\n"))
# define GIFT_ERROR(args) (fprintf (stderr, "** gift-error:   "), printf args, printf ("\n"))
# define GIFT_WARN(args)  (fprintf (stderr, "** gift-warning: "), printf args, printf ("\n"))
# define GIFT_FATAL(args) (fprintf (stderr, "** gift-fatal:   "), printf args, printf ("\n")), exit (1)
# define trace()           fprintf (stderr, "%-15s:%-4i %s\n", __FILE__, __LINE__, __PRETTY_FUNCTION__)
#else  /* !DEBUG */
# define GIFT_DEBUG(args)
# define GIFT_ERROR(args)
# define GIFT_WARN(args)
# define GIFT_FATAL(args)
# define trace()
#endif /* DEBUG */

/*****************************************************************************/

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

/*****************************************************************************/

#ifndef MIN
#define MIN(x,y)              ((x < y) ? x : y)
#endif

#ifndef MAX
#define MAX(x,y)              ((x > y) ? x : y)
#endif

#ifndef CLAMP
#define CLAMP(value,min,max)  ((value < min) ? min : ((value > max) ? max : value))
#endif

/*****************************************************************************/

#endif /* __GIFT_H */
